com.fasterxml.jackson.databind

## Class AbstractTypeResolver

- java.lang.Object
- - com.fasterxml.jackson.databind.AbstractTypeResolver

- Direct Known Subclasses:
    SimpleAbstractTypeResolver

      public abstract class AbstractTypeResolver
      extends Object

  Defines interface for resolvers that can resolve abstract types into concrete ones; either by using static mappings, or possibly by materializing implementations dynamically.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractTypeResolver()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `JavaType` | `findTypeMapping(DeserializationConfig config, JavaType type)` Try to locate a subtype for given abstract type, to either resolve to a concrete type, or at least to a more-specific (and hopefully supported) abstract type, one which may have registered deserializers.
    `JavaType` | `resolveAbstractType(DeserializationConfig config, BeanDescription typeDesc)` Method called to try to resolve an abstract type into concrete type (usually for purposes of deserializing), when no concrete implementation was found.
    `JavaType` | `resolveAbstractType(DeserializationConfig config, JavaType type)` Deprecated. since 2.8 (may be removed from 2.9 or later)

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractTypeResolver

          public AbstractTypeResolver()

  - ### Method Detail

    - #### findTypeMapping

          public JavaType findTypeMapping(DeserializationConfig config,
                                          JavaType type)

      Try to locate a subtype for given abstract type, to either resolve to a concrete type, or at least to a more-specific (and hopefully supported) abstract type, one which may have registered deserializers. Method is called before trying to locate registered deserializers (as well as standard abstract type defaulting that core Jackson does), so it is typically implemented to add custom mappings of common abstract types (like specify which concrete implementation to use for binding `List`s).

      Note that this method does not necessarily have to do full resolution of bindings; that is, it is legal to return type that could be further resolved: caller is expected to keep calling this method on registered resolvers, until a concrete type is located.

      Parameters:
        `config` - Configuration in use
        `type` - Type to find mapping for
      Returns:
        Type to map given input type (if mapping found) or `null` (if not).

    - #### resolveAbstractType

          @Deprecated
          public JavaType resolveAbstractType(DeserializationConfig config,
                                                          JavaType type)

      Deprecated. since 2.8 (may be removed from 2.9 or later)
      Older variant of `resolveAbstractType(DeserializationConfig, BeanDescription)`; obsoleted in 2.7
      Parameters:
        `config` - Configuration in use
        `type` - Type to resolve
      Returns:
        Resolved concrete type

    - #### resolveAbstractType

          public JavaType resolveAbstractType(DeserializationConfig config,
                                              BeanDescription typeDesc)

      Method called to try to resolve an abstract type into concrete type (usually for purposes of deserializing), when no concrete implementation was found. It will be called after checking all other possibilities, including defaulting.
      Parameters:
        `config` - Configuration in use
        `typeDesc` - Description of the POJO type to resolve
      Returns:
        Resolved concrete type (which should retain generic type parameters of input type, if any), if resolution succeeds; null if resolver does not know how to resolve given type
      Since:
        2.7

Copyright © 2008–2020 FasterXML. All rights reserved.